//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// Z O M B I E   T O R R E N T   2 
// AMMO RELATED FUNCTIONS
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Struct for a "type" of ammo
// Used for weapons that can have more than one type

struct AmmoType
{
	str Class;
	str Display;
	str Prefix;
	str Icon;
	str BG;
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Can this weapon be reloaded?
bool ReloadAllowed()
{
	int WI = LocalWeaponIndex();
	
	if (CheckInventory( WeaponList[WI].SecondaryClass ) <= 0)
		return false;
	
	int ammoP = CheckInventory( WeaponList[WI].PrimaryClass );
	int ammoMax = WeaponList[WI].PrimaryCap;
	
	return (ammoP < ammoMax);
}

script "ReloadAllowed" (void) { SetResultValue( ReloadAllowed() ); }

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Perform ammo-based reload magic

void ReloadMagic()
{
	int WI = LocalWeaponIndex();
	
	str ClassP = WeaponList[WI].PrimaryClass;
	str ClassS = WeaponList[WI].SecondaryClass;
	int CapP = WeaponList[WI].PrimaryCap;
	
	// How much ammo can we possibly take?
	int CanTake = min( CapP - CheckInventory(ClassP), CheckInventory(ClassS) );
	if (CanTake <= 0)
		return;
		
	TakeInventory(ClassS, CanTake);
	GiveInventory(ClassP, CanTake);
}

script "ReloadMagic" (void) { ReloadMagic(); }