// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Z O M B I E   T O R R E N T   2
// MAIN DEBUGGING FILE
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// ------------------------/
// Debug spawners
// ------------------------/

script "SpawnerDebug" (void) NET
{
	for (int i=0; i<spawnSpotsSize; i++)
	{
		if (spawnSpots[i].Pulses > 0)
			PrintBold(s:"YES");
		else
			PrintBold(s:"NO");
	}
	
	SpawnZombie();
}

// ------------------------/
// Debug players
// ------------------------/

script "PlayerDebug" (void) NET
{
	str debugString = "\cDPLAYER DEBUG:\n";
	debugString = StrParam(s:debugString, s:"\cIWE ARE PLAYER \cK", d:PlayerNumber(), s:"\n\n");
	
	for (int i=0; i<MAXPLAYERS; i++)
	{
		if (!PlayerInGame(i) && !PlayerIsSpectator(i))
			continue;
			
		str AliveString = PlayerState[i].Alive ? "\cDALIVE" : "\cGDEAD";
		str ReadyString = PlayerState[i].Ready ? "\cKREADY" : "\cINOT READY";
		
		str nameString = StrParam(n:i);
		
		debugString = StrParam(s:debugString, s:"\cJ", d:i, s:". ");
		debugString = StrParam(s:debugString, s:nameString, s:" - ", s:AliveString, s:" ", s:ReadyString, s:"\n");
	}
	
	Print(s:debugString);
	Print(s:"\cDCheck console for results.");
}

// ------------------------/
// Debug traders
// ------------------------/

script "TraderDebug" (void) NET
{
	str debugString = "\cDTRADER DEBUG:\n";
	
	for (int i=0; i<TraderArraySize; i++)
	{
		debugString = StrParam(s:debugString, s:"\cJ", d:i, s:". ");
		debugString = StrParam(s:debugString, s:"\cKDoor ID: \cJ", d:TraderArray[i].DoorID);
		debugString = StrParam(s:debugString, s:" \Spot ID: \cJ", d:TraderArray[i].SpotID, s:"\n");
	}
	
	PrintBold(s:debugString);
}

// ------------------------/
// Benchmark function
// Executes a specific script over and over
// ------------------------/

script "Benchmark" NET
{
	int iterations = 0;
	str ScriptName = GetCVarString("cl_zt2benchmark");
	
	if (StrLen(ScriptName) <= 0)
	{
		PrintBold(s:"\cJBenchmark script not set, use \cKcl_zt2benchmark \cJto set one.");
		terminate;
	}
	
	PrintBold(s:"\cJPerforming benchmark on \cK", s:ScriptName, s:"\cJ...");
	
	while (iterations < BENCHMARK_ITERATIONS)
	{
		for (int l=0; l<BENCHMARK_BATCHSIZE; l++)
		{
			ACS_NamedExecuteAlways(ScriptName, 0);
			iterations ++;
		}
		
		delay(1);
	}
	
	PrintBold(s:"Script ", s:ScriptName, s:" run for ", d:BENCHMARK_ITERATIONS, s:" iterations.\nUse the ACSProfile command to check results.");
}

// ------------------------/
// Test for showing HUD messages
// ------------------------/
script "HUDTest"
{
	SetFont("BIOTIME1");
	HUDMessageUnscaled(64.0, 64.0, "a", ALIGN_LEFT, ALIGN_TOP, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(-64.0, 64.0, "a", ALIGN_RIGHT, ALIGN_TOP, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(64.0, -64.0, "a", ALIGN_LEFT, ALIGN_BOTTOM, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(-64.0, -64.0, "a", ALIGN_RIGHT, ALIGN_BOTTOM, 100, 5.0);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void ZTPrint(str msg) { Log(s:msg); }