// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - REPLICATION
// Mostly RELIABLE things from client -> server
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

enum RepTypes
{
	MSG_ZOMBIECOUNT,				// Zombie count
	MSG_TIMECOUNT,					// Countdown / trader time
	MSG_GAMESTATE,					// The game state
};

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

struct ZT2Replication
{
	bool RequestingState;					// Requesting the initial gamestate!
	bool SendingResolution;					// Telling the server what our res is
};

struct ZT2Replication Replication;

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// ResolutionSender
// Client [Wait]
// ------------------------/

script "ResolutionSender" (int ResX, int ResY)
{
	Replication.SendingResolution = true;
	
	while (true)
	{
		NamedRequestScriptPuke("ResolutionPing", ResX, ResY, ConsolePlayerNumber(), 0);
		delay(REPLICATION_INTERVAL);
		
		// Received a response
		if (!Replication.SendingResolution)
			break;
	}
}

// ------------------------/
// ResolutionPing
// Client -> Server
// ------------------------/

script "ResolutionPing" (int ResX, int ResY) NET
{
	int PN = PlayerNumber();
	
	PlayerState[PN].ResX = ResX;
	PlayerState[PN].ResY = ResY;
	ACS_NamedExecuteAlways("ResolutionPong", 0);
}

// ------------------------/
// ResolutionPong
// Server -> Client
// ------------------------/

script "ResolutionPong" CLIENTSIDE
{
	if( WrongClient() )
		terminate;
		
	Replication.SendingResolution = false;
	
	ZTPrint("ResolutionPong");
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// StateRequest
// Client [Wait]
// ------------------------/

script "StateRequest_Wait"
{
	Replication.RequestingState = true;
	
	while (true)
	{
		NamedRequestScriptPuke("StateRequest_Ping", 0, 0, 0, 0);
		delay(REPLICATION_INTERVAL);
		
		// Received a response
		if (!Replication.RequestingState)
			break;
	}
};

// ------------------------/
// StateRequest
// Client -> Server
// ------------------------/

script "StateRequest_Ping" NET
{
	// Send a pong response back to the originator
	ACS_NamedExecute("StateRequest_Pong", 0);
	
	// Now let's actually send updated gamestates to people who don't have them
	// (Doing a check in the client script is useless, since
	// everyone will execute it regardless)
	
	// Timing / zombie count
	Rep_UpdateCount();
}

// ------------------------/
// StateRequest
// Server -> Client
// ------------------------/

script "StateRequest_Pong" CLIENTSIDE
{
	if (WrongClient())
		terminate;
	
	Replication.RequestingState = false;
	
	ZTPrint("StateRequest_Pong");
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Send a gamestate update message
// Server -> Client
// ------------------------/

script "UpdateGameState" (int msg, int a, int b) CLIENTSIDE
{
	switch (msg)
	{
		// Zombies left
		case MSG_ZOMBIECOUNT:
			GameState.HUD.ZombiesLeft = a;
			ZTPrint("MSG_ZOMBIECOUNT");
			
			// Ensure we're in a wave
			if (IsClient())
				GameState.State = STATE_WAVE;
		break;
		
		// Timing variable
		case MSG_TIMECOUNT:
			GameState.HUD.TimeLeft = a;
			
			if (IsClient())
				GameState.WaveTimer = a;
				
			ZTPrint("MSG_TIMECOUNT");
		break;
		
		// Game state
		case MSG_GAMESTATE:
			GameState.State = a;
			GameState.Wave = b;
			ReceivedStateChange();
			ZTPrint("MSG_GAMESTATE");
		break;
	}
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Send gamestate to clients
// ------------------------/

void Rep_UpdateState()
{
	ACS_NamedExecuteAlways("UpdateGameState", 0, MSG_GAMESTATE, GameState.State, GameState.Wave);
}

// ------------------------/
// Sends time, etc. to clients
// ------------------------/

void Rep_UpdateCount()
{
	// Send a timing value
	if (GameState.State == STATE_TRADER || GameState.State == STATE_COUNTDOWN)
		ACS_NamedExecuteAlways("UpdateGameState", 0, MSG_TIMECOUNT, GameState.WaveTimer);
	else
		ACS_NamedExecuteAlways("UpdateGameState", 0, MSG_ZOMBIECOUNT, RemainingZombies(), 600);
}

// ------------------------/
// The server sent us a state change
// ------------------------/
void ReceivedStateChange()
{
	PrintBold(s:"PN: ", d:PlayerNumber());
	
	// Wave REALLY started!
	if (GameState.State == STATE_WAVE)
		ShowFightImage();
		
	// Trader time!
	// Doing AmbientSound should be fine, on the client end
	else if (GameState.State == STATE_TRADER)
		AmbientSound("wave/completed", 127);
}